package com.example.notefullproyect.subtask.model

import androidx.room.Entity
import androidx.room.ForeignKey
import androidx.room.ForeignKey.Companion.CASCADE
import androidx.room.PrimaryKey
import com.example.notefullproyect.priority.model.Priority
import com.example.notefullproyect.progress.model.Progress
import com.example.notefullproyect.task.model.Task

/**
 *  SubTask entity with an autogenerated id.It has three foreignKeys taskId, priorityId and progressId.
 * Contains  initial values to progressId and quantityTime.
 * Description property can be null.
 * @constructor title, description, taskId, priorityId.
 * @author Jessica Castillo
 */
@Entity(
    foreignKeys = [
        ForeignKey(
            entity = Task::class,
            parentColumns = ["id"],
            childColumns = ["taskId"],
            onDelete = CASCADE
        ),
        ForeignKey(
            entity = Priority::class,
            parentColumns = ["id"],
            childColumns = ["priorityId"],
            onDelete = CASCADE
        ),
        ForeignKey(
            entity = Progress::class,
            parentColumns = ["id"],
            childColumns = ["progressId"],
            onDelete = CASCADE
        )
    ]
)
data class SubTask(
    var title: String,
    var description: String?,
    var taskId: Int,
    var priorityId: Int
) {
    @PrimaryKey(autoGenerate = true)
    var id: Int = 0
    var progressId: Int = 1
    var quantityTime: Int = 0
}

